#include <iostream>
#include <vector>

struct IncompleteLogError { };

template<class T> class LogIterator {
  private:
    T &t;
    typename T::iterator i;

  public:
      LogIterator(T &t): t(t), i(t.begin()) { }

      LogIterator operator ++ (int) {
        LogIterator res(*this);
        ++i;
        return res;
      }

      typename T::value_type &operator * () const {
        if(i == t.end()) {
          throw IncompleteLogError();
        }

        return *i;
      }
};

class BusinessObject {
  private:
    std::vector<std::string> eventLog;

    template<class I> void logic(I &i) {
      if( *i++ == "Enter lair"
       && *i++ == "Aim Lazor"
       && *i++ == "Activate"
       && *i++ == "Muahahaha"
       && *i++ == "???"
       && *i++ == "Profit!") {
        std::cout << "World domination!" << std::endl;
      }
    }

  public:
    void input(const std::string &s) {
      eventLog.push_back(s);

      auto i = LogIterator<std::vector<std::string>>(eventLog);

      try {
        logic(i);
      } catch(IncompleteLogError e) {
        // we expected this
      }
    }

};

int main(void) {
  BusinessObject bo;
  bo.input("Enter lair");
  bo.input("Aim Lazor");
  bo.input("Activate");
  bo.input("Muahahaha");
  bo.input("???");
  bo.input("Profit!");
}
